''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' JPG-Illuminator install script
' Version 4.1.6, 2010-01-11
' (c) 2009, 2010, Bertram Hafner & Franz Speckert
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Const JPGILLU_APP = "jpgIlluminator.exe"
Const JPGILLU_FRIENDLYNAME = "JPG-Illuminator"
Const JPGILLU_DESCRIPTION = "Bearbeitet Bilddateien im JPEG-Format"
Const JPGILLU_APPDATAFOLDER = "jpg-Illuminator"
Const JPGILLU_OLDVERB = "ffnen mit JPG-Illuminator"
Const JPGILLU_EDITVERB = "edit.ji"
Const JPGILLU_EDITVERB_FRIENDLYNAME = "Bearbeiten mit JPG-Illuminator"

Dim shell
Dim fso
Dim appPath
Dim bDoIt

Set shell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")

bDoIt = IsElevated()
If Not bDoIt Then
	If MsgBox("Hiermit wird " & JPGILLU_FRIENDLYNAME & " installiert." & vbCrLf & vbCrLf & _
			  "Die Installation ist nicht unbedingt erforderlich, jedoch werden Explorer-Meneintrge" & vbCrLf & _
			  "und eine Desktop-Verknpfung zum bequemen Aufruf von " & JPGILLU_FRIENDLYNAME & " erstellt." & vbCrLf & vbCrLf & _
			  "Mchten Sie mit der Installation fortfahren?", vbExclamation + vbYesNo + vbDefaultButton1, JPGILLU_FRIENDLYNAME) = vbYes Then
		bDoIt = GetElevatedRights()
	End If
End If

If bDoIt Then

	appPath= fso.GetParentFolderName(WScript.ScriptFullName)
	If Right(appPath, 1) <> "\" Then appPath = appPath & "\"
	appPath = appPath & JPGILLU_APP

	If Not fso.FileExists(appPath) Then
		MsgBox JPGILLU_FRIENDLYNAME & " konnte nicht installiert werden." & vbCrLf & "Die Programmdatei wurde nicht gefunden.", vbCritical, JPGILLU_FRIENDLYNAME
	Else

		On Error Resume Next
		' enter file associations (optional)
		Call CreateFlexibleFileTypeAssoc(".jpg", JPGILLU_EDITVERB, JPGILLU_EDITVERB_FRIENDLYNAME, appPath)
		Call CreateFlexibleFileTypeAssoc(".bmp", JPGILLU_EDITVERB, JPGILLU_EDITVERB_FRIENDLYNAME, appPath)
		' enter standard application entries
		Err.Clear
		shell.RegWrite "HKCR\Applications\" & JPGILLU_APP & "\shell\open\FriendlyAppName", JPGILLU_FRIENDLYNAME
		shell.RegWrite "HKCR\Applications\" & JPGILLU_APP & "\shell\open\command\", """" & appPath & """ ""%1"""
		If Err.Number = 0 Then
			CreateDesktopShortcut JPGILLU_FRIENDLYNAME, appPath, JPGILLU_DESCRIPTION
		End If
		If Err.Number = 0 Then
			MsgBox JPGILLU_FRIENDLYNAME & " wurde erfolgreich installiert.", vbInformation, JPGILLU_FRIENDLYNAME
		Else
			MsgBox "Bei der Installation von " & JPGILLU_FRIENDLYNAME & " ist ein Fehler aufgetreten:" & vbCrLf & _
				Err.Source & ": " & Err.Description & vbCrLf & _
				"Mglicherweise verfgen Sie nicht ber die Berechtigung diesen Vorgang durchzufhren.", _
				vbCritical, JPGILLU_FRIENDLYNAME
		End If
		On Error GoTo 0
		
	End If
End If

Private Function TestRights()
	On Error Resume Next
	shell.RegWrite "HKCR\ji_test_entry\", "hello ji"
	shell.RegDelete "HKCR\ji_test_entry\"
	TestRights = CBool(Err.Number = 0)
	On Error GoTo 0
End Function

Private Function IsElevated()
	IsElevated = False
	If WScript.Arguments.length > 0 Then
		If StrComp(WScript.Arguments(0), "/elevated", vbTextCompare) = 0 Then IsElevated = True
	End if
End Function

Private Function GetElevatedRights()
	GetElevatedRights = IsElevated()
	If Not GetElevatedRights Then
		If TestRights() Then GetElevatedRights = True
	End If
	If Not GetElevatedRights Then
		' invoke runas prompt/uac
		CreateObject("Shell.Application").ShellExecute "wscript.exe", """" & WScript.ScriptFullName & """ /elevated", "", "runas", 1
	End If
End Function

Private Function CreateFlexibleFileTypeAssoc(ByVal aFileType, ByVal aVerb, ByVal aFriendlyVerb, ByVal aAppPath)
	Dim assocDocType, keyName
	Dim ErrNumber, ErrSource, ErrDescription

	' store error information
	ErrNumber = Err.Number
	ErrSource = Err.Source
	ErrDescription = Err.Description

	On Error Resume Next
	
	' check availibilty of HKEY_CLASSES_ROOT\SystemFileAssociations
	keyName = "HKCR\SystemFileAssociations\" & aFileType & "\"
	Err.Clear
	Call shell.RegRead(keyName)
	If Err.Number = 0 Then
		' use SystemFileAssociations method 
		keyName = keyName & "shell\" & aVerb & "\"
		shell.RegWrite keyName, aFriendlyVerb
		shell.RegWrite keyName & "command\", """" & aAppPath & """ ""%1"""
	Else
		' standard method
		assocDocType = ""
		assocDocType = shell.RegRead("HKCR\" & aFileType & "\")
		If Len(assocDocType) = 0 Then
			assocDocType = aFileType
		End If
		Err.Clear
		keyName = "HKCR\" & assocDocType & "\shell\" & aVerb & "\"
		shell.RegWrite keyName, aFriendlyVerb
		shell.RegWrite keyName & "command\", """" & aAppPath & """ ""%1"""
		If (Err.Number = 0) Then
			shell.RegWrite "HKCR\" & aFileType & "\" & fso.GetBaseName(aAppPath) & "\AssocDocType", assocDocType
		End If
	End If
	
	CreateFlexibleFileTypeAssoc = CBool(Err.Number = 0)

	If ErrNumber <> 0 Then
		' restore previous error information
		Err.Raise ErrNumber, ErrSource, ErrDescription
	Else
		Err.Clear
	End If
End Function

Private Function CreateShortcut(ByVal aLinkPath, ByVal aTargetPath, ByVal aDescription, ByVal aWorkingDirectory)
	Dim oShellLink
	Dim ErrNumber, ErrSource, ErrDescription

	' store error information
	ErrNumber = Err.Number
	ErrSource = Err.Source
	ErrDescription = Err.Description

	On Error Resume Next

	Set oShellLink = shell.CreateShortcut(aLinkPath & ".lnk")

	oShellLink.TargetPath = aTargetPath
	oShellLink.Description = aDescription
	oShellLink.WorkingDirectory = aWorkingDirectory

	oShellLink.Save

	CreateShortcut = CBool(Err.Number = 0)

	If ErrNumber <> 0 Then
		' restore previous error information
		Err.Raise ErrNumber, ErrSource, ErrDescription
	Else
		Err.Clear
	End If
End Function

Private Sub CreateDesktopShortcut(ByVal aLinkName, ByVal aTargetPath, ByVal aDescription)
	Dim strDesktop

	strDesktop = shell.SpecialFolders("AllUsersDesktop")
	If Len(strDesktop) > 0 Then
		' try allusers desktop
		If Not CreateShortcut(strDesktop & "\" & aLinkName, aTargetPath, aDescription, "") Then
			strDesktop = ""
		End If
	End If
	If Len(strDesktop) = 0 Then
		' try current desktop
		strDesktop = shell.SpecialFolders("Desktop")
		CreateShortcut strDesktop & "\" & aLinkName, aTargetPath, aDescription, strDesktop
	End If
End Sub
