''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' JPG-Illuminator uninstall Script
' Version 4.1.6, 2010-01-11
' (c) 2009, 2010, Bertram Hafner & Franz Speckert
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Const JPGILLU_APP = "jpgIlluminator.exe"
Const JPGILLU_OLDFRIENDLYNAME = "JPEG-Illuminator"
Const JPGILLU_FRIENDLYNAME = "JPG-Illuminator"
Const JPGILLU_DESCRIPTION = "Bearbeitet Bilddateien im JPEG-Format"
Const JPGILLU_APPDATAFOLDER = "jpg-Illuminator"
Const JPGILLU_OLDVERB = "ffnen mit JPG-Illuminator"
Const JPGILLU_EDITVERB = "edit.ji"
Const JPGILLU_EDITVERB_FRIENDLYNAME = "Bearbeiten mit JPG-Illuminator"

Dim shell
Dim fso
Dim appKey
Dim bDoIt

Set shell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")

bDoIt = IsElevated()
If Not bDoIt Then
	If MsgBox("Hiermit wird " & JPGILLU_FRIENDLYNAME & " deinstalliert." & vbCrLf & vbCrLf & _
			  "Das Programm wird nicht gelscht, jedoch werden die Explorer-Meneintrge" & vbCrLf & _
			  "und die Desktop-Verknpfung von " & JPGILLU_FRIENDLYNAME & " entfernt." & vbCrLf & vbCrLf & _
			  "Mchten Sie mit der Deinstallation fortfahren?", vbExclamation + vbYesNo + vbDefaultButton2, JPGILLU_FRIENDLYNAME) = vbYes Then
		bDoIt = GetElevatedRights()
	End If
End If

If bDoIt Then

	On Error Resume Next
	appKey = ""
	appKey = shell.RegRead("HKCR\Applications\" & JPGILLU_APP & "\shell\open\command\")
	On Error GoTo 0

	If Len(appKey) = 0 Then
		MsgBox JPGILLU_FRIENDLYNAME & " ist nicht installiert.", vbExclamation, JPGILLU_FRIENDLYNAME
	Else

		On Error Resume Next
		' remove optional file associations
		Call RemoveFlexibleFileTypeAssoc(".bmp", JPGILLU_OLDVERB, JPGILLU_EDITVERB, JPGILLU_APP)
		Call RemoveFlexibleFileTypeAssoc(".jpg", JPGILLU_OLDVERB, JPGILLU_EDITVERB, JPGILLU_APP)
		' remove entries used by some previous versions
		shell.RegDelete "HKCR\.bmp\OpenWithList\" & JPGILLU_APP & "\"
		shell.RegDelete "HKCR\.jpg\OpenWithList\" & JPGILLU_APP & "\"
		' remove standard application entries
		Err.Clear
		shell.RegDelete "HKCR\Applications\" & JPGILLU_APP & "\shell\open\command\"
		shell.RegDelete "HKCR\Applications\" & JPGILLU_APP & "\shell\open\"
		shell.RegDelete "HKCR\Applications\" & JPGILLU_APP & "\shell\"
		shell.RegDelete "HKCR\Applications\" & JPGILLU_APP & "\"
		RemoveDesktopShortcut JPGILLU_OLDFRIENDLYNAME
		RemoveDesktopShortcut JPGILLU_FRIENDLYNAME
		If MsgBox("Sollen die zuletzt benutzten Einstellungen und Filter-Presets von " & JPGILLU_FRIENDLYNAME & " ebenfalls entfernt werden?" & vbcrlf & vbCrLf & _
		          "Antworten Sie mit Nein, wenn Sie diese Einstellungen spter noch bentigen.", vbQuestion + vbYesNo + vbDefaultButton2, JPGILLU_FRIENDLYNAME) = vbYes Then
			RemoveAppDataFolder JPGILLU_APPDATAFOLDER
		End If
		If Err.Number = 0 Then
			MsgBox JPGILLU_FRIENDLYNAME & " wurde erfolgreich deinstalliert.", vbInformation, JPGILLU_FRIENDLYNAME
		Else
			MsgBox "Bei der Deinstallation von " & JPGILLU_FRIENDLYNAME & " ist ein Fehler aufgetreten:" & vbCrLf & _
				Err.Source & ": " & Err.Description & vbCrLf & _
				"Mglicherweise verfgen Sie nicht ber die Berechtigung diesen Vorgang durchzufhren.", _
				vbCritical, JPGILLU_FRIENDLYNAME
		End If
		On Error GoTo 0

	End If
End If

Private Function TestRights()
	On Error Resume Next
	shell.RegWrite "HKCR\ji_test_entry\", "hello ji"
	shell.RegDelete "HKCR\ji_test_entry\"
	TestRights = CBool(Err.Number = 0)
	On Error GoTo 0
End Function

Private Function IsElevated()
	IsElevated = False
	If WScript.Arguments.length > 0 Then
		If StrComp(WScript.Arguments(0), "/elevated", vbTextCompare) = 0 Then IsElevated = True
	End if
End Function

Private Function GetElevatedRights()
	GetElevatedRights = IsElevated()
	If Not GetElevatedRights Then
		If TestRights() Then GetElevatedRights = True
	End If
	If Not GetElevatedRights Then
		' invoke runas prompt/uac
		CreateObject("Shell.Application").ShellExecute "wscript.exe", """" & WScript.ScriptFullName & """ /elevated", "", "runas", 1
	End If
End Function

Private Function RemoveFlexibleFileTypeAssoc(ByVal aFileType, ByVal aOldVerb, ByVal aVerb, ByVal aAppName)
	Dim assocDocType, keyName
	Dim ErrNumber, ErrSource, ErrDescription

	' store error information
	ErrNumber = Err.Number
	ErrSource = Err.Source
	ErrDescription = Err.Description

	RemoveFlexibleFileTypeAssoc = True
	
	On Error Resume Next

	' check availibilty of HKEY_CLASSES_ROOT\SystemFileAssociations
	keyName = "HKCR\SystemFileAssociations\" & aFileType & "\shell\" & aVerb & "\"
	Err.Clear
	Call shell.RegRead(keyName)
	If Err.Number = 0 Then
		' use SystemFileAssociations method 
		shell.RegDelete keyName & "command\"
		shell.RegDelete keyName
		RemoveFlexibleFileTypeAssoc = RemoveFlexibleFileTypeAssoc And CBool(Err.Number = 0)
	End If
	
	' remove also standard entries
	' retrieve the associated document type first
	keyName = "HKCR\" & aFileType & "\" & fso.GetBaseName(aAppName) & "\"
	assocDocType = ""
	assocDocType = shell.RegRead(keyName & "AssocDocType")
	If Len(assocDocType) = 0 Then
		assocDocType = aFileType
	Else
		shell.RegDelete keyName
	End If
	
	' remove old verb if available
	keyName = "HKCR\" & assocDocType & "\shell\" & aOldVerb & "\"
	Err.Clear
	Call shell.RegRead(keyName)
	If Err.Number = 0 Then
		shell.RegDelete keyName & "command\"
		shell.RegDelete keyName
		RemoveFlexibleFileTypeAssoc = RemoveFlexibleFileTypeAssoc And CBool(Err.Number = 0)
	End If
	
	' remove new verb if available
	keyName = "HKCR\" & assocDocType & "\shell\" & aVerb & "\"
	Err.Clear
	Call shell.RegRead(keyName)
	If Err.Number = 0 Then
		shell.RegDelete keyName & "command\"
		shell.RegDelete keyName
		RemoveFlexibleFileTypeAssoc = RemoveFlexibleFileTypeAssoc And CBool(Err.Number = 0)
	End If

	If ErrNumber <> 0 Then
		' restore previous error information
		Err.Raise ErrNumber, ErrSource, ErrDescription
	Else
		Err.Clear
	End If
End Function

Private Function RemoveShortcut(ByVal aLinkPath)
	Dim ErrNumber, ErrSource, ErrDescription

	' store error information
	ErrNumber = Err.Number
	ErrSource = Err.Source
	ErrDescription = Err.Description

	On Error Resume Next

	fso.DeleteFile aLinkPath & ".lnk"

	RemoveShortcut = CBool(Err.Number = 0)

	If ErrNumber <> 0 Then
		' restore previous error information
		Err.Raise ErrNumber, ErrSource, ErrDescription
	Else
		Err.Clear
	End If
End Function

Private Sub RemoveDesktopShortcut(ByVal aLinkName)
	Dim strDesktop

	strDesktop = shell.SpecialFolders("AllUsersDesktop")
	If Len(strDesktop) > 0 Then
		RemoveShortcut strDesktop & "\" & aLinkName
	End If

	strDesktop = shell.SpecialFolders("Desktop")
	RemoveShortcut strDesktop & "\" & aLinkName
End Sub

Private Sub RemoveAppDataFolder(ByVal aFolderName)
	Dim sAppDataFolder

	sAppDataFolder = shell.SpecialFolders("AppData")

	If Len(sAppDataFolder) > 0 Then
		sAppDataFolder = sAppDataFolder & "\" & aFolderName
		If fso.FolderExists(sAppDataFolder) Then
			fso.DeleteFolder sAppDataFolder
		End If
	End If
End Sub
